# -*- Mode: Python; tab-width: 4 -*-

import socket
import shell
import windll
user32 = windll.module ('user32')
kernel32 = windll.module ('kernel32')
cstring = windll.cstring

# TODO: allow the user to specify a mailbox file,
# and watch that, too:  So that when the mailbox
# file changes, we might check again?
#
# TODO: let the user specify a message-processing
# module (maybe from the command line?)...  this
# could turn out to be quite handy for those without
# an Emacs.
#
# TODO: support APOP now that the qpopper does.

import listview

# constants from win32con
LB_RESETCONTENT	= 388
LB_ADDSTRING	= 384
WM_INITDIALOG	= 272
WM_LBUTTONDOWN	= 513
WM_RBUTTONDOWN	= 516
WM_DESTROY		= 2
WM_TIMER		= 275
WM_COMMAND		= 273
IDCANCEL		= 2
IDOK			= 1

def is_console ():
	temp = windll.cstring ('', 64)
	if kernel32.GetConsoleTitle (temp, len (temp)):
		return 1
	else:
		return 0

import sys

if not is_console():
	if '-d' in sys.argv:
		fd = open ('./cperrs.txt', 'wb')
		sys.stderr = sys.stdout = fd
		print 'checkpop3 debug file'
		sys.stdout.flush()
	res = kernel32.GetModuleHandle (0)
else:
	# Load resources from the dll
	res = kernel32.LoadLibrary (cstring ('.\\checkres.dll'))

# LoadIcon can't load non-standard image sizes, we must use LoadImage
IMAGE_ICON = 1
icon_unknown	= user32.LoadImage (res, 105, IMAGE_ICON, 16, 16, 0)
icon_empty		= user32.LoadImage (res, 104, IMAGE_ICON, 16, 16, 0)
icon_unempty	= user32.LoadImage (res, 106, IMAGE_ICON, 16, 16, 0)
icon_error		= user32.LoadImage (res, 108, IMAGE_ICON, 16, 16, 0)

hmenu = user32.LoadMenu (res, 107)

# for debug, lets me look up message names.
#import winmesg

import string
import sys
import pop3_2

# we will have a message loop
import asyncore

# returns LOWORD, HIWORD
def SPLIT_WORD (x):
	return (x&0xffff, (x>>16))

# states:
# looking up host
# bad data (hostname, username, password)
# checking
# waiting

class pop3_checker:
	def __init__ (self):
		self.host = cstring ('', 63)
		self.user = cstring ('', 63)
		self.pwd = cstring ('', 63)
		self.status = cstring ('', 511)
		self.error = None
		self.last_state = 'unknown'
		self.timer_id = 0
		self.num_messages = 0

	def set_error (self, error):
		self.set_icon ('error')
		self.set_status (error)
		self.minutes = 0

	def set_status (self, status):
		self.status.write (status)
		user32.SetDlgItemText (self.hwnd, 1005, self.status)
		self.set_tip (status)

	def connect_fun (self, status):
		if status:
			self.set_status ('sending STAT command...')
			self.pc.stat (self.stat_fun)
		else:
			self.set_error (status.reason)

	def stat_fun (self, status, num, length):
		if status:
			if num > 0:
				if num > self.num_messages:
					# distinctive blee-bloop tone
					kernel32.Beep (1000, 50)
					kernel32.Beep (500,150)

				self.num_messages = num
				if num == 1:
					self.set_status ('1 message')
				else:
					self.set_status ('%d messages' % num)
				self.set_icon ('unempty')
				self.get_headers (num)
			else:
				self.set_status ('no messages')
				self.set_icon ('empty')
				self.clear_listbox()
				self.num_messages = 0
				self.pc.quit (self.quit_fun)

	def get_headers (self, n):
		self.clear_listbox()
		hc = pop3_2.n_collector (n, self.header_fun, self.header_done_fun)
		for i in range(n):
			self.pc.top (i+1, 0, hc.n_line_fun, hc.n_done_fun)

	def get_list (self):
		lv = listview.list_view (
			'message_list',
			hwnd=user32.GetDlgItem (self.hwnd, 1007)
			)
		lv.set_style (lv.get_style() | listview.LVS_REPORT)
		return lv

	def clear_listbox (self):
		user32.SendMessage (
			self.list,
			listview.LVM_DELETEALLITEMS,
			0,
			0
			)

	def header_fun (self, lines):
		f = 'unknown'
		s = 'unknown'
		for line in lines:
			if string.lower (line[:6]) == 'from: ':
				f = line[6:]
			elif string.lower (line[:9]) == 'subject: ':
				s = line[9:]

		self.list.insert_item (f, sub_item=0)
		self.list.set_item (s, sub_item=1)		

	def header_done_fun (self, status):
		self.pc.quit (self.quit_fun)

	def quit_fun (self, status):
		user32.KillTimer (self.hwnd, 1010)
		user32.KillTimer (self.hwnd, 1020)
		if self.minutes:
			self.timer_id = user32.SetTimer (self.hwnd, 1020, self.minutes*60*1000, 0)
		self.pc.client.close()
		self.pc = None

	def set_icon (self, state):
		if state != self.last_state:
			if state == 'unknown':
				icon = icon_unknown
			elif state == 'empty':
				icon = icon_empty
			elif state == 'error':
				icon = icon_error
			else:
				icon = icon_unempty
			result, self.nid = shell.notify_icon (
				shell.NIM_MODIFY,
				hWnd = self.hwnd,
				uID = 1064,
				hIcon = icon,
				uFlags = shell.NIF_ICON
				)
			self.last_state = state
			#print state, icon, result

	def set_tip (self, tip):
		if len(tip) > 63:
			tip = tip[:62]
		result, self.nid = shell.notify_icon (
			shell.NIM_MODIFY,
			hWnd = self.hwnd,
			uFlags = shell.NIF_TIP,
			uID = 1064,
			szTip = tip
			)

	def start_query (self):
		if self.host:
			try:
				ip = socket.gethostbyname (self.host.trunc())
			except:
				self.set_error ('hostname lookup failed on <%s>' % self.host.trunc())
				return
			self.timer_id = user32.SetTimer (self.hwnd, 1010, 100, 0)
			self.pc = pop3_2.pop3_controller (
				ip,
				self.user.trunc(),
				self.pwd.trunc()
				)
			self.set_icon ('unknown')
			self.set_status ('connecting...')
			self.pc.connect (self.connect_fun)

	def dlg_proc (self, dlg, msg, wparam, lparam):
		try:
			if msg == WM_INITDIALOG:
				result, self.nid = shell.notify_icon (
					shell.NIM_ADD,
					uID		= 1064,
					hWnd	= dlg,
					uFlags	= (shell.NIF_ICON | shell.NIF_MESSAGE),
					uCallbackMessage = 0x8100,
					hIcon	= icon_unknown
					)
				self.hwnd = dlg
				self.list = self.get_list()
				self.list.insert_column (1, 'From', width=100)
				self.list.insert_column (2, 'Subject', width=100)
				return 0
			elif msg == 0x8100:
				# wparam = uID, lparam = msg
				# handle mouse messages from the icon
				if lparam == WM_RBUTTONDOWN:
					#x, y = SPLIT_WORD (lparam)
					user32.ShowWindow (dlg, 1)
					# this doesn't work yet.
					#user32.TrackPopupMenu (hmenu, 0, x, y, 0, dlg, 0)
				elif lparam == WM_LBUTTONDOWN:
					if not self.pc:
						self.start_query()
				return 1
			elif msg == WM_DESTROY:
				result, nid = shell.notify_icon (
					shell.NIM_DELETE,
					hWnd = dlg,
					uID = 1064
					)
				user32.KillTimer (self.hwnd, 1010)
				user32.KillTimer (self.hwnd, 1020)
				return 1
			elif msg == WM_TIMER:
				if wparam == 1010:
					# this is a socket timer message
					asyncore.poll (0.0)
				elif wparam == 1020:
					self.start_query()
			elif msg == WM_COMMAND:
				if wparam == IDCANCEL:
					user32.EndDialog (dlg, 1)
				elif wparam == 1006:
					user32.GetDlgItemText (dlg, 1000, self.host, len(self.host))
					user32.GetDlgItemText (dlg, 1001, self.user, len(self.user))
					user32.GetDlgItemText (dlg, 1002, self.pwd, len(self.pwd))
					self.minutes = user32.GetDlgItemInt (dlg, 1004, 0, 0)
					self.start_query()
				elif wparam == 1003:
					user32.ShowWindow (dlg, 0)
				return 1
			else:
				return 0
		except:
			import tb
			import sys
			print sys.exc_type, sys.exc_value
			tb.printtb (sys.exc_traceback)
			return 0

pc = pop3_checker()

import gencb
cb = gencb.callback ('llll', pc.dlg_proc)

user32.DialogBoxParam (res, 103, 0, cb.address, 0)

