# -*- Mode: Python; tab-width: 4 -*-

NIM_ADD		= 0x00000000
NIM_MODIFY	= 0x00000001
NIM_DELETE	= 0x00000002

NIF_MESSAGE	= 0x00000001
NIF_ICON	= 0x00000002
NIF_TIP		= 0x00000004

import windll
	
# load the shell DLL
shell32 = windll.module ('shell32')

import structob

# typedef struct _NOTIFYICONDATAA {
#		  DWORD cbSize;
#		  HWND hWnd;
#		  UINT uID;
#		  UINT uFlags;
#		  UINT uCallbackMessage;
#		  HICON hIcon;
#		  CHAR	 szTip[64];
# } NOTIFYICONDATAA, *PNOTIFYICONDATAA;

class NOTIFY_ICON_DATA (structob.struct_object):
	oracle = structob.Oracle (
		'Notify Icon Data',
		'Lllllll64c',
		('cbSize',
		 'hWnd',
		 'uID',
		 'uFlags',
		 'uCallbackMessage',
		 'hIcon',
		 'szTip'
		 )
		)

# WINSHELLAPI BOOL WINAPI
# Shell_NotifyIconA (
#	DWORD dwMessage,
#	PNOTIFYICONDATAA lpData
#	);

def make_tip_string (s):
	l = len(s)
	if l > 63:
		raise ValueError, 'string too long (> 63 chars)'
	r = 64 - l
	s = map (None, s)
	return tuple(s + (['\000',] * r))

def notify_icon (message, **icon_data):
	#global fnord
	#fnord = icon_data
	nid = NOTIFY_ICON_DATA()
	nid.cbSize = nid.size
	# transform the tip string
	if icon_data.has_key ('szTip'):
		icon_data['szTip'] = make_tip_string (icon_data['szTip'])
	nid._set_values (icon_data)
	return (
		shell32.Shell_NotifyIconA (message, nid),
		nid
		)
